


//#define SI5351_ADDRESS 0x60
//#define SYSTEM_CORE_CLOCK 48000000
//#define FUNCONF_SYSTEM_CORE_CLOCK 48000000
//#define APB_CLOCK SYSTEM_CORE_CLOCK

//#define SYSTEM_CORE_CLOCK 28375160
//#define FUNCONF_SYSTEM_CORE_CLOCK 28375160

//#define SYSTEM_CORE_CLOCK 14187580
//#define FUNCONF_SYSTEM_CORE_CLOCK 14187580
#define SYSTEM_CORE_CLOCK 7093790
#define FUNCONF_SYSTEM_CORE_CLOCK 7093790

#define APB_CLOCK SYSTEM_CORE_CLOCK 


#include "ch32v003fun.h"
#include <stdio.h>
//#include "i2c.h"
//#include "si5351.h"
#include <string.h>

#define WRITE   0
#define READ    1
#define NOP     "nop \n"    \

#define NOPx10  "nop \n"    \
	            "nop \n"    \
	            "nop \n"    \
	            "nop \n"    \
	            "nop \n"    \
	            "nop \n"    \
	            "nop \n"    \
	            "nop \n"    \
	            "nop \n"    \
	            "nop \n"    \

#define NOPx100 NOPx10	\
				NOPx10	\
				NOPx10	\
				NOPx10	\
				NOPx10	\
				NOPx10	\
				NOPx10	\
				NOPx10	\
				NOPx10	\
				NOPx10	\


int main()
{
	SystemInit();                       
	
    funGpioInitC();
    funGpioInitA();

 
    funPinMode( PC4, GPIO_Speed_50MHz | 0x1c);
    funPinMode( PC1, GPIO_Speed_50MHz | GPIO_CNF_OUT_PP );
    funPinMode( PA2, GPIO_Speed_50MHz | 0x48);
    funPinMode( PC2, GPIO_Speed_50MHz | GPIO_CNF_IN_PUPD );
    
    //uint32_t    sync = 0 ;
	uint32_t	s1 = 1;
    uint32_t    counter = 0 ;
    uint8_t     vg = 0b00;
	
	while(1)
	{
		if (funDigitalRead(PA2))
		{
        	while (funDigitalRead(PC2))
			{
				//sync = funDigitalRead(PC2);
				s1 = funDigitalRead(PC4);
				if(s1 == 0 ) 
				{ 
					counter++;

					if (counter > 3500000) 
					{
						vg = vg + 0x01;
						counter = 0 ;
						//if (vg > 1 ) {NVIC_SystemReset();	}		
					}
				}

			}// if PA2 (S1) is set to LOW 

		vg = vg & 0x01;
		if (vg != 0x00)

			{
			//Wait for /CSYNC
			while (!funDigitalRead(PC2))
			{
				//sync = funDigitalRead(PC2);
			}        
			
			//Waiting for BURST
			funDigitalWrite( PC1, FUN_HIGH );
			__asm volatile (
				NOPx10
				NOPx10
				NOPx10
			);

			//Delete Left edge
			funDigitalWrite( PC1, FUN_LOW );
			__asm volatile (
				NOPx10 
				NOPx10 
				NOPx10 
				NOPx10 
				NOPx10 
				NOPx10 
				NOP
				NOP
				

			);

			//Display screen
			funDigitalWrite( PC1, FUN_HIGH );
			__asm volatile (
				NOPx100
				NOPx100
				NOPx100
				NOPx100
				NOPx100
				NOPx100
				NOPx10
				NOPx10
				NOPx10
				NOPx10
				NOPx10
				NOPx10
			);

			//Delete Right Edge
			funDigitalWrite( PC1, FUN_LOW );
			__asm volatile (
				NOPx10
				NOPx10
				NOPx10
				NOPx10
				NOPx10
				NOP
				NOP
				NOP
				NOP
				NOP
			);

			}//end vg == 1
			
			
		if (!funDigitalRead(PA2)) 
		{ 
			funDigitalWrite( PC1, FUN_HIGH );
		}
		}//if(vg == 0b01)
	
		else 
		{
			funDigitalWrite( PC1, FUN_HIGH );
			//vg = 0x00;
		}

    } //while(1)

}
        

